﻿from os import chdir

chdir("F:\Formation NSI\Séquence IA\Images")



from PIL import Image
import numpy as np
#imgpil = Image.open("Image A.bmp")
imgpil = Image.open("Bases images triangles\Image Triangle 10.bmp")
# imgpil = Image.open("Bases images carres\Image Carre 10.bmp")
# imgpil = Image.open("Bases images disques\Image disque 10.bmp")

# anciennement np.asarray
img = np.array(imgpil) # Transformation de l'image en tableau numpy


a = img[12]
# for i in range(0,16):
    # if (a[i][0] == 255):
        # print(i,"Blanc")
    # else:
        # print(i,"Noir")

import matplotlib.pyplot as plt
# plt.imshow(img)
# plt.show()

imgpil.getpixel((0,0))


def compterPixelsNoirs(image):
    NB_LIGNES = image.size[0]
    NB_COLONNES = image.size[1]
    resultat = 0
    for i in range(0,NB_LIGNES):
        for j in range(0,NB_COLONNES):
            if image.getpixel((i,j))[0] == 0:
                resultat+=1
    return resultat



imgTraitee = np.copy(img)
def compterPixelsNoirsPerimetre(image):
    NB_LIGNES = image.size[0]
    NB_COLONNES = image.size[1]
    resultat = 0
    for i in range(0,NB_LIGNES):
        for j in range(0,NB_COLONNES):
            if image.getpixel((i,j))[0] == 0:
                if image.getpixel((i-1,j))[0] != 0 or image.getpixel((i+1,j))[0] != 0 or image.getpixel((i,j-1))[0] != 0 or image.getpixel((i,j+1))[0] != 0:
                    imgTraitee[j][i] = [255,255,0]
                    resultat+=1
    return resultat



def barycentreImage(image):
    NB_LIGNES = image.size[0]
    NB_COLONNES = image.size[1]
    sommeX = 0
    nbX = 0
    sommeY = 0
    nbY = 0
    for i in range(0,NB_LIGNES):
        for j in range(0,NB_COLONNES):
            if image.getpixel((i,j))[0] == 0:
                sommeX = sommeX+i
                nbX += 1
                sommeY = sommeY+j
                nbY += 1
    return [sommeX/nbX , sommeY/nbY]

b = barycentreImage(imgpil)

PointPPD = [0,0]

def plusPetiteDistanceBarycentreImage(image):
    b = barycentreImage(image)
    NB_LIGNES = image.size[0]
    NB_COLONNES = image.size[1]
    distance = NB_LIGNES**2 + NB_COLONNES**2
    for i in range(0,NB_LIGNES):
        for j in range(0,NB_COLONNES):
            # if image.getpixel((i,j))[0] == 0:
            if image.getpixel((i,j))[0] == 0 and (image.getpixel((i-1,j))[0] != 0 or image.getpixel((i+1,j))[0] != 0 or image.getpixel((i,j-1))[0] != 0 or image.getpixel((i,j+1))[0] != 0):
                d = ((i-b[0])**2+(j-b[1])**2)**(1/2)
                if d < distance:
                    distance = d
                    PointPPD[0] = i
                    PointPPD[1] = j
    return distance

PointPGD = [0,0]

def plusGrandeDistanceBarycentreImage(image):
    b = barycentreImage(image)
    NB_LIGNES = image.size[0]
    NB_COLONNES = image.size[1]
    distance = 0
    for i in range(0,NB_LIGNES):
        for j in range(0,NB_COLONNES):
            # if image.getpixel((i,j))[0] == 0:
            if image.getpixel((i,j))[0] == 0 and (image.getpixel((i-1,j))[0] != 0 or image.getpixel((i+1,j))[0] != 0 or image.getpixel((i,j-1))[0] != 0 or image.getpixel((i,j+1))[0] != 0):
                d = ((i-b[0])**2+(j-b[1])**2)**(1/2)
                if d > distance:
                    distance = d
                    PointPGD[0] = i
                    PointPGD[1] = j
    return distance

PPD = plusPetiteDistanceBarycentreImage(imgpil)
PGD = plusGrandeDistanceBarycentreImage(imgpil)


A = compterPixelsNoirs(imgpil)
# print(A)
P = compterPixelsNoirsPerimetre(imgpil)
# print(P)

imgTraitee[round(b[1]) , round(b[0])] = [0,0,255]
imgTraitee[round(PointPPD[1]) , round(PointPPD[0])] = [255,0,0]
imgTraitee[round(PointPGD[1]) , round(PointPGD[0])] = [0,255,0]


# print(PPD)
# print(PGD)
# print(PointPPD)
# print(PointPGD)

print("quotient PGD / PPD : ",PGD/PPD)
print("quotient P² / A : ",P**2 / A)

plt.imshow(imgTraitee)
plt.show()

IndicateursTrianglesPGDoPPD = [1.886 , 1.959 , 1.952 , 1.952 , 1.952 , 2.126 , 1.852 , 2.005 , 2.020 , 2.037]
IndicateursTrianglesPcoA = [13.157 , 15.367 , 15.277 , 15.277 , 15.277 , 19.386 , 13.056 , 15.364 , 14.787 , 15.265 ]

IndicateursCarresPGDoPPD = [1.414 , 1.414 , 1.425 , 1.394 , 1.404 , 1.489 ,  1.442 , 1.476 , 1.485 , 1.429]
IndicateursCarresPcoA = [15.638 , 15.073 , 15.501 , 7.780 , 7.919 , 13.380 , 14.168 , 13.886 , 11.710 , 12.978]

IndicateursDisquesPGDoPPD = [1.137 , 1.041 , 1.084 , 1.147 , 1.160 , 1.094 , 1.097 , 1.170 , 1.139 , 1.071]
IndicateursDisquesPcoA = [8.526 , 10.056 , 9.711 , 9.940 , 10.194 , 9.572 , 9.536 , 9.843 , 9.966 , 9.0]

plt.plot(IndicateursTrianglesPGDoPPD,IndicateursTrianglesPcoA,'r^')
plt.plot(IndicateursCarresPGDoPPD,IndicateursCarresPcoA,'ys')
plt.plot(IndicateursDisquesPGDoPPD,IndicateursDisquesPcoA,'bo')
plt.show()






